searchNodes=[{"ref":"Conductor.html","title":"Conductor","type":"module","doc":"Conductor main functionality. When added to phoenix controller, it will generate all plugs necessary for authorization. use Conductor"},{"ref":"Conductor.Error.html","title":"Conductor.Error","type":"exception","doc":""},{"ref":"Conductor.Plugs.Authorize.html","title":"Conductor.Plugs.Authorize","type":"module","doc":"Plug added to controllers by Conductor macro It takes list of scopes as option, concatenates it with list of root scopes and check assings inside conn. If at least one scope from conn is on list of authorized scopes then action can be performed. Otherwise it will respond according to choosen failure strategy (default: raise Conductor.Error) If you would like to require multiple scopes at once, inclose them in tuple. For example: @authorize scope: {&quot;scope1&quot;, &quot;scope2&quot;} def action(conn, _params), do: ... In order to perform action both &quot;scope1&quot; and &quot;scope2&quot; must be assigned inside conn."},{"ref":"Conductor.Plugs.Authorize.html#call/2","title":"Conductor.Plugs.Authorize.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"Conductor.Plugs.Authorize.html#init/1","title":"Conductor.Plugs.Authorize.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"Conductor.Plugs.SkipAuthorization.html","title":"Conductor.Plugs.SkipAuthorization","type":"module","doc":"Add this plug wherever you need to disable authorization. pipeline :skip_authorization do plug Conductor.Plugs.SkipAuthorization end scope &quot;/public&quot; do pipe_through [:skip_authorization] #... end"},{"ref":"Conductor.Plugs.SkipAuthorization.html#call/2","title":"Conductor.Plugs.SkipAuthorization.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"Conductor.Plugs.SkipAuthorization.html#init/1","title":"Conductor.Plugs.SkipAuthorization.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"readme.html","title":"Conductor","type":"extras","doc":"Conductor Simple package for api authorization."},{"ref":"readme.html#when-is-this-package-good","title":"Conductor - When is this package good","type":"extras","doc":"when you need to restrict access to most endpoints when exposing some to third party developers when you don&#39;t want to spam your controllers with plugs for every action when you must respond according to existing permission system (e.g. scopes in jwt)"},{"ref":"readme.html#when-is-this-package-not-good","title":"Conductor - When is this package not good","type":"extras","doc":"when you need authentication when you need authorization for html pages when you need advanced permissions management system"},{"ref":"readme.html#installation","title":"Conductor - Installation","type":"extras","doc":"def deps do [{:conductor, &quot;~&gt; 0.4.0&quot;}] end"},{"ref":"readme.html#conductor-macro","title":"Conductor - Conductor macro","type":"extras","doc":"Basically, this: defmodule Controller do use Conductor # Important! It needs to be before use Phoenix.Controller use Phoenix.Controller def index(conn, _params), do: #... def show(conn, _params), do: #... @authorize scope: &quot;scope1&quot; def create(conn, _params), do: #... @authorize scope: {&quot;scope1&quot;, &quot;scope2&quot;} def update(conn, _params), do: #... @authorize scope: &quot;scope2&quot; def delete(conn, _params), do: #... end will be compiled to this: defmodule Controller do use Conductor use Phoenix.Controller plug Conductor.Plugs.Authorize, [&quot;scope1&quot;] when action in [:create] plug Conductor.Plugs.Authorize, [{&quot;scope1&quot;, &quot;scope2&quot;}] when action in [:update] plug Conductor.Plugs.Authorize, [&quot;scope2&quot;] when action in [:delete] plug Conductor.Plugs.Authorize, [] when not action in [:create, :update, :delete] def index(conn, _params), do: #... def show(conn, _params), do: #... def create(conn, _params), do: #... def update(conn, _params), do: #... def delete(conn, _params), do: #... end"},{"ref":"readme.html#root-scope","title":"Conductor - Root scope","type":"extras","doc":"You can register scope that will have full access everywhere config :conductor, root_scopes: [&quot;admin&quot;]"},{"ref":"readme.html#adding-scopes","title":"Conductor - Adding scopes","type":"extras","doc":"conn |&gt; Plug.Conn.assign(:scopes, [&quot;scope1, scope2&quot;])"},{"ref":"readme.html#public-access","title":"Conductor - Public access","type":"extras","doc":"defmodule Router do pipeline :public do plug Conductor.Plugs.SkipAuthorization end scope &quot;/public&quot;, MyApp do pipe_through [:public] get &quot;/something&quot;, SomethingController, :something end end"},{"ref":"readme.html#authorization-failures","title":"Conductor - Authorization failures","type":"extras","doc":"To avoid confusion with random 403 response codes that come from nowhere, Conductor will raise error on authorization failure as default. This can be changed by following config config :conductor, on_auth_failure: :send_resp"},{"ref":"readme.html#example","title":"Conductor - Example","type":"extras","doc":"#config config :conductor, root_scopes: [&quot;root_scope&quot;], on_auth_failure: :send_resp #router pipeline :public do plug Conductor.Plugs.SkipAuthorization end scope &quot;/&quot;, Example do get &quot;/2&quot;, Controller, :action2 get &quot;/3&quot;, Controller, :action3 get &quot;/4&quot;, Controller, :action4 get &quot;/5&quot;, Controller, :action5 end scope &quot;/&quot;, Example do pipe_through [:public] get &quot;/1&quot;, Controller, :action1 end #conns conn1 = Phoenix.ConnTest.build_conn() conn2 = conn1 |&gt; Plug.Conn.assign(:scopes, [&quot;scope1&quot;]) conn3 = conn1 |&gt; Plug.Conn.assign(:scopes, [&quot;scope1&quot;, &quot;scope2&quot;]) conn4 = conn1 |&gt; Plug.Conn.assign(:scopes, [&quot;root_scope&quot;]) #endpoints @authorize scope: &quot;scope1&quot; def action1(conn, _params), do: conn |&gt; send_resp(200, &quot;&quot;) @authorize scope: &quot;scope2&quot; def action2(conn, _params), do: conn |&gt; send_resp(200, &quot;&quot;) @authorize scope: {&quot;scope1&quot;, &quot;scope2} def action3(conn, _params), do: conn |&gt; send_resp(200, &quot;&quot;) def action4(conn, _params), do: conn |&gt; send_resp(200, &quot;&quot;) @authorize scopes: [&quot;other&quot;, &quot;unused&quot;] def action5(conn, _params), do: conn |&gt; send_resp(200, &quot;&quot;) conn1conn2conn3conn4 action1200200200200 action2403200200200 action3403403200200 action4403403403200 action5403403403200"},{"ref":"readme.html#customization","title":"Conductor - Customization","type":"extras","doc":"Global Failure response status code # config/config.exs config :conductor, :failure_status, 418 Failure response body # view defmodule MyApp.Web.ExampleView do use MyApp.Web, :view def render(&quot;403.json&quot;, _assigns) do %{message: &quot;Forbidden&quot;} end end # config/config.exs config :conductor, :failure_template, {MyApp.Web.ExampleView, &quot;403.json&quot;}"},{"ref":"readme.html#license","title":"Conductor - License","type":"extras","doc":"Copyright 2017-2019 Tobiasz Małecki tobiasz.malecki@appunite.com Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#0-4-0-2019-01-24","title":"Changelog - 0.4.0 (2019-01-24)","type":"extras","doc":"Allowed to require multiple scopes at once #5"},{"ref":"changelog.html#0-3-0-2017-09-26","title":"Changelog - 0.3.0 (2017-09-26)","type":"extras","doc":"Global customization of failure responses #3"},{"ref":"changelog.html#0-2-1-2017-06-19","title":"Changelog - 0.2.1 (2017-06-19)","type":"extras","doc":"Readme and docs improvement"},{"ref":"changelog.html#0-2-0-2017-05-28","title":"Changelog - 0.2.0 (2017-05-28)","type":"extras","doc":"BREAKING root_scope config replaced by root_scopes, it has to be list now @authorize now accepts :scope or :scopes for respectively single scope and list of scopes Compilation error will be raised when single @authorize attribute contain both :scope and :scopes"}]